function [w,wx,wy,wxx,wyy,wxy] = weight_PUM(x,cen,R)
if length(R)==1
   R1 = R; R2 = R; else R1 = R(:,1); R2 = R(:,2);
end
dx = x(:,1) - cen(:,1); dy = x(:,2) - cen(:,2); r = hypot(dx./R1,dy./R2); 
phi = (4*r + 1).*(1 - r).^4;
phix=20*dx.*(-1+r).^3./R1.^2;
phiy=20*dy.*(-1+r).^3./R2.^2;
if r==0
    phixx=-20/R1.^2; phiyy=-20/R2.^2; phixy=0;
else
    phixx=20*(-1+r).^2.*(-r+4*(dx.^2./R1.^2)+(dy.^2./R2.^2))./R1.^2./r;
    phiyy=20*(-1+r).^2.*(-r+(dx.^2./R1.^2)+4*(dy.^2./R2.^2))./R2.^2./r;
    phixy=60*dy.*(-1+r).^2./R2.^2./r.*dx./R1.^2;
end
s = sum(phi);     w = phi/s;
sx = sum(phix);   wx = phix/s - phi*sx/s^2;
sy = sum(phiy);   wy = phiy/s - phi*sy/s^2;
sxx = sum(phixx); wxx = -2*phix*sx/s^2 + phixx/s + phi*(2*sx^2/s^3 - sxx/s^2);
syy = sum(phiyy); wyy = -2*phiy*sy/s^2 + phiyy/s + phi*(2*sy^2/s^3 - syy/s^2);
sxy = sum(phixy); wxy=phixy/s-phix*sy/s^2-phiy*sx/s^2-phi*sxy/s^2+2*sy*sx*phi/s^3;
