function [w,wx,wy,wxx,wyy,wxy] = imq_PUM(ep,xc,xe)
A = zeros(length(xc),length(xc));
for i=1:length(xc)
    r2 = (xc(:,1) - xc(i,1)).^2 + (xc(:,2) - xc(i,2)).^2;
    A(:,i) = 1./sqrt(1 + ep^2*r2);
end
dx = xe(1,1) - xc(:,1); dy = xe(1,2) - xc(:,2); r2 = dx.^2 + dy.^2;
Ae = 1./sqrt(1 + ep^2*r2);   w = Ae'/A;
Aex = -ep^2*dx.*Ae.^3;      wx = Aex'/A;
Aey = -ep^2*dy.*Ae.^3;      wy = Aey'/A;
Aexx = (3*dx.^2*ep^4).*Ae.^5 - ep^2*Ae.^3; wxx = Aexx'/A;
Aeyy = (3*dy.^2*ep^4).*Ae.^5 - ep^2*Ae.^3; wyy = Aeyy'/A;
Aexy = (3*dx.*dy*ep^4).*Ae.^5; wxy = Aexy'/A;